<?php
/*
Plugin Name: Wordpress Gravatars
Plugin URI: http://wordpress.org/extend/plugins/wp-gravatar/
Description: Makes use of Gravatars and MyBlogLog Avatars, places Gravatars or MyBlogLog Avatars in the comments section. Uses the comment authors email to display their Gravatar. It also gives the user an Author Profile picture, based on his or hers <strong>Gravatar</strong>. Change your options <a href="themes.php?page=gravatar">here</a>. As of version 2.2 there is also a widget for <em>Recent Comments</em> with Gravatars.
Version: 2.5
Author: Rune Gulbrandsøy
Author URI: http://bloggs.be/wpmu/gravatar/
*/

/*
  Copyright 2007 Rune (http://bloggs.be/rune/)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


*/

/*
The idea for the Favicon parts come from the plugin favatars by Jeff Minard (http://thecodepro.com/). I have used some of his codem and rewritten some of the parts i have used.
Thanks to Petter (http://neppe.no) for the tips about a nofollow option!
*/

function gravatar_admin_menu(){
    add_submenu_page('themes.php', 'Gravatar', 'Gravatar', 8, 'gravatar', 'gravatar_admin');
    
}

function show_gravatar($s) {
$gravatar = get_option('bruk_gravatar');
$gravatar_align = get_option('bruk_gravatar_align');
$default = get_option('default_gravatar');
$gravatar_use_url = get_option('bruk_gravatar_url');
$gravatar_use_url_follow = get_option('bruk_gravatar_url_follow');
$home_url = get_option('bruk_gravatar_home_url');
$use_favico = get_option('bruk_gravatar_favico');
$use_mbl = get_option('bruk_mbl_ikon');
if($gravatar == true){
	global $comment;
	$comment_tekst = $comment->get_comment_text;
if ( !empty( $comment->comment_author_email ) ) {
        $lowercase = strtolower($comment->comment_author_email);
        $md5 = md5( $lowercase );
        //$default == $default_gravatar;
        $comment_name = $comment->comment_author;
        if ( $comment->comment_author_url == 'http://' || $comment->comment_author_url == '') {
        	$comment_link = get_option('home');
        	}else{
        	$comment_link = $comment->comment_author_url;
        	if ($use_favico == true){
        	$favicon_url = getFavicon($comment_link);
    		$default = $favicon_url;
    		if ($default == '')
    			$default = get_option('default_gravatar');
    			}
        	}
        if ($use_mbl == true && $default == get_option('default_gravatar')){
        	$default = "http://pub.mybloglog.com/coiserv.php?href=mailto:" . $lowercase . "&amp;n=". $lowercase;
        	}
        //edit the style to what you want, the standard style looks good on most themes.
        if($gravatar_use_url_follow == true){
       			 	$follow_links = "rel='external nofollow'";
       			 	} else {
       			 	$follow_links = "rel='external'";
       			 	}
        if($gravatar_align == true){
        	if($home_url == true && $comment_link != get_option('home')){
       			$s = "<a href='$comment_link' $follow_links>$comment_name</a><a href='$comment_link' $follow_links><img style='float: right; border: none;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=40&amp;default=$default' alt='' /></a>";
       		} else {
       		if ($gravatar_use_url == true){
       			$s = "<a href='$comment_link' $follow_links>$comment_name</a><a href='$comment_link' $follow_links><img style='float: right; border: none;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=40&amp;default=$default' alt='' /></a>";
       		}else{	
       			$s = "$comment_name<img style='float: right; border: none;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=40&amp;default=$default' alt='' />";
       		}}
		}else{
			if($home_url == true && $comment_link != get_option('home')){
       			 $s = "<a href='$comment_link' $follow_links>$comment_name</a><a href='$comment_link' $follow_links><img style='float: left; margin-right: 10px; border: none;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=40&amp;default=$default' alt='' /></a>";
       		} else {
       		if ($gravatar_use_url == true){
       			$s = "<a href='$comment_link' $follow_links>$comment_name</a><a href='$comment_link' $follow_links><img style='float: left; margin-right: 10px; border: none;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=40&amp;default=$default' alt='' /></a>";
       		}else{	
       			$s = "$comment_name<img style='float: left; margin-right: 10px; border: none;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=40&amp;default=$default' alt='' />";
       		}}
		}}
	return $s;
}
return $s;
}

function show_gravatar_post($s) {
$gravatar = get_option('bruk_gravatar');
$gravatar_align = get_option('bruk_gravatar_align');
$default = get_option('default_gravatar');
$post_gravatar = get_option('bruk_gravatar_post');
//$s = "Dette skal ikke komme";
	if($post_gravatar == true){
	global $post;
       $epost = get_the_author_email();
        $lowercase = strtolower($epost);
        $md5 = md5($lowercase);
        $content=$s;
        $s= "<img style='float: left; margin-right: 10px; border: none;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=20&amp;default=$default' alt=''/>";
		$s=$s."$content";
		}
	return $s;
	
}



function gravatar_admin(){
global $userdata;
get_currentuserinfo();
$current_user = $userdata->ID;
	$default_gravatar = get_option('default_gravatar');
		if ($default_gravatar != '') {
			$default_gravatar_temp = $default_gravatar;
			}else{
			$default_gravatar_temp = "http://use.perl.org/images/pix.gif";
			}
	$gravatar = get_option('bruk_gravatar');
	$gravatar_align = get_option('bruk_gravatar_align');
	$gravatar_profil = get_option('bruk_gravatar_profil');
	$gravatar_url = get_option('bruk_gravatar_url');
	$gravatar_url_follow = get_option('bruk_gravatar_url_follow');
	$gravatar_home_url = get_option('bruk_gravatar_home_url');
	$gravatar_favico = get_option('bruk_gravatar_favico');
	$gravatar_uid = get_option('bruk_gravatar_uid');
	$gravatar_post = get_option('bruk_gravatar_post');
	$use_mbl = get_option('bruk_mbl_ikon');
	if ($gravatar_uid != ' '){
		$temp_uid = $gravatar_uid;
		}else{
		$temp_uid = '1';
		}
	$version = "2.5";
	
	
	if ($_POST['updatinggravatar']) {
		$temp_grav = $_POST['defaultgravataroption'];
		
		if ($_POST['bruke_gravatar']) {
			$gravatar = true;
			
		} else {
			$gravatar = false;
			
		}
		
		 if ($_POST['bruke_gravatar_align']){
		 	$gravatar_align = true;
		 	} else {
		 	$gravatar_align = false;
		 	}
		 if ($_POST['bruke_gravatar_profil']){
		 	$gravatar_profil = true;
		 	} else {
		 	$gravatar_profil = false;
		 	}
		 	
		 if ($_POST['bruk_gravatar_post']){
		 	$gravatar_post = true;
		 	} else {
		 	$gravatar_post = false;
		 	}
		 	
		  if ($_POST['bruk_gravatar_url']){
		 	$gravatar_url = true;
		 	} else {
		 	$gravatar_url = false;
		 	}
		 if ($_POST['bruk_gravatar_url_follow']){
		 	$gravatar_url_follow = true;
		 	} else {
		 	$gravatar_url_follow = false;
		 	}
		 if ($_POST['bruk_gravatar_home_url']){
		 	$gravatar_home_url = true;
		 	} else {
		 	$gravatar_home_url = false;
		 	}
		 if ($_POST['bruk_gravatar_favico']){
		 	$gravatar_favico = true;
		 	} else {
		 	$gravatar_favico = false;
		 	}
		 if ($_POST['bruk_mbl_ikon']){
		 	$use_mbl = true;
		 	} else {
		 	$use_mbl = false;
		 	}
		 
		 if ($_POST['default_gravatar']){
		 	$default_gravatar = $_POST['default_gravatar'];
		 	}
		  if ($_POST['bruk_gravatar_uid']){
		 	$gravatar_uid = $_POST['bruk_gravatar_uid'];
		 	}
			
			
			
		 
		update_option('bruk_gravatar', $gravatar);
		update_option('bruk_gravatar_align', $gravatar_align);
		update_option('bruk_gravatar_profil', $gravatar_profil);
		update_option('bruk_gravatar_post', $gravatar_post);
		update_option('bruk_gravatar_url', $gravatar_url);
		update_option('bruk_gravatar_url_follow', $gravatar_url_follow);
		update_option('bruk_gravatar_home_url', $gravatar_home_url);
		update_option('bruk_gravatar_favico', $gravatar_favico);
		update_option('default_gravatar', $default_gravatar);
		update_option('bruk_gravatar_uid', $gravatar_uid);
		update_option('bruk_mbl_ikon', $use_mbl);
	echo '<div id="message" class="updated fade"><p>Your choices has been updated</p></div>';
	
	}

?>
<div class="wrap">
<h2><?php _e('Gravatars')?></h2>
<form action="" method="post">
<div class="wrap">
<h4><?php _e('Gravatars or MyBlogLog - or both?');?></h4>
<p><label><input name="bruke_gravatar" value="gravatar" type="checkbox" <?php if ($gravatar) { ?> checked="checked" <?php } ?> /> Use Gravatars with your comments.</label></p>
<p><label><input name="bruk_mbl_ikon" value="use_mbl" type="checkbox" <?php if ($use_mbl) { ?> checked="checked" <?php } ?> /> Use MyBlogLog avatars with your comments. <small>This will override your sites default Gravatar with MyBlogLog's default Avatar.</small></label></p>
<p><label><input name="bruk_gravatar_favico" value="gravatar_favico" type="checkbox" <?php if ($gravatar_favico) { ?> checked="checked" <?php } ?> /> Replace the sites standard Gravatar with the users websites <em>favico.ico</em> image. If the site does not have a <em>favico.ico</em> file, the sites standard Gravatar will be used. <br/> <small>The use of this option <em><strong>WILL</strong></em> slow down the loading of single pages/posts and the front page and is not recommended.</small></label></p>
<br/>
<p><label><?php _e('Default Gravatar to use (complete URI (eg <em>http://domain.tld/default.jpg</em>)&nbsp;<input type="text" name="default_gravatar" value="' . $default_gravatar_temp . '" size="50"/>')?><br/>
<?php _e('<small>Current default Gravatar : ' . $default_gravatar_temp . ' <img src="' . $default_gravatar_temp . '" width="30px" height="30px"/></small>')?></label></p>
</div>
<div class="wrap">
<h4><?php _e('Links');?></h4>
<p><label><input name="bruk_gravatar_home_url" value="gravatar_home_url" type="checkbox" <?php if ($gravatar_home_url) { ?> checked="checked" <?php } ?> /> Gravatars and name will link back to commenters site</em></label></p>
<p><label><input name="bruk_gravatar_url" value="gravatar_url" type="checkbox" <?php if ($gravatar_url) { ?> checked="checked" <?php } ?> /> Gravatars and name for users with no given blog/url link will be linked back to:  <em><?php echo get_option('home'); ?></em></label></p>
<p><label><input name="bruk_gravatar_url_follow" value="gravatar_url_follow" type="checkbox" <?php if ($gravatar_url_follow) { ?> checked="checked" <?php } ?> /> Use &lt;<em>rel=external nofollow</em>&gt; with links to commenters sites.</label></p>
</div>
<div class="wrap">
<h4><?php _e('Alignment/Placement');?></h4>
<p><label><input name="bruke_gravatar_align" value="gravatar_align" type="checkbox" <?php if ($gravatar_align) { ?> checked="checked" <?php } ?> /> Place the Gravatar on the right side of the comments (default is the left side).</label></p>
<p><label><input name="bruk_gravatar_post" value="gravatar_post" type="checkbox" <?php if ($gravatar_post) { ?> checked="checked" <?php } ?> /> Use your Gravatar with your blog posts. This will always be on the left side, before your content.</label></p>
</div>
<div class="wrap">
<h4><?php _e('Widgets');?></h4>
<p><label><input name="bruke_gravatar_profil" value="gravatar_profil" type="checkbox" <?php if ($gravatar_profil) { ?> checked="checked" <?php } ?> /> Use the <strong>Author Profile</strong> widget (you have to activate the widget from the widget page).</label>
<label><?php _e('User ID for show with profile widget (eg <em>1</em>)&nbsp;<input type="text" name="bruk_gravatar_uid" value="' . $temp_uid . '" size="2"/>&nbsp;(<small>Your user ID is <strong><em>' . $current_user . '</em></strong></small>)')?></label></p>
<p><label>If your theme does not support widgets, you can place <em>&lt;?php ShowGravatar(x);?&gt;</em> in to your <em>sidebar.php</em>. Replace the <em><strong>x</strong></em> with the author number to show. You can place as many <em>&lt;?php ShowGravatar(x);?&gt;</em> as you want.</label></p>
</div>
<div class="wrap">
<h4><?php _e('Support');?></h4>
<p><?php _e('If you do not have a Gravatar, you can get your very own over at the <a href="http://site.gravatar.com/signup">Gravatar</a> site.')?></p>
<p><label>For support, please visit <a href="http://bloggs.be/wpmu/gravatar/">http://bloggs.be/wpmu/gravatar/</a>.</label></p>
<p><?php _e('<small>&copy; <a href="http://bloggs.be/wpmu/gravatar/">Rune G</a> You are using version :<strong>' . $version . '</strong> of WP-Gravatar</small>')?></p>
</div>
<p class="submit">
	<input value="Update Gravatars &raquo;" type="submit" />
	<input name="updatinggravatar" value="true" type="hidden" /></p>
</form>
</div>
<?php
}

function widget_authdescription_init() {

	// Check for the required API functions
	if ( !function_exists('register_sidebar_widget') || !function_exists('register_widget_control') )
		return;

	// This saves options and prints the widget's config form.
	function widget_authdescription_control() {
		$options = $newoptions = get_option('widget_authdescription');
		if ( $_POST['authdescription-submit'] ) {
			$newoptions['title'] = strip_tags(stripslashes($_POST['authdescription-title']));
			$newoptions['alignall'] = strip_tags(stripslashes($_POST['authdescription-alignall']));
					$alignall = $newoptions['alignall'];
					if ($alignall == "left")       {$imgalign = 'float:left;margin:5px;';}
					elseif ($alignall == "center") {$imgalign = 'display:block;margin:5px auto 0 auto;';}
					elseif ($alignall == "right")  {$imgalign = 'float:right;margin:5px;';}
					else echo 'Pick alignment again...';
				$newoptions['imgalign'] = $imgalign;
			$newoptions['bordercolor'] = strip_tags(stripslashes($_POST['authdescription2-bordercolor']));
		}
		if ( $options != $newoptions ) {
			$options = $newoptions;
			update_option('widget_authdescription', $options);
		}
		$imgalign = htmlspecialchars($options['imgalign'], ENT_QUOTES);
		$bordercolor = htmlspecialchars($options['bordercolor'], ENT_QUOTES);
	?>
				<div style="text-align:right">
				<label for="authdescription-title" style="line-height:35px;display:block;">Titel: <input type="text" id="authdescription-title" name="authdescription-title" value="<?php echo htmlspecialchars($options['title']); ?>" /></label>
				<input type="hidden" name="authdescription-submit" id="authdescription-submit" value="1" />
				</div>
	<?php
	}

	// This prints the widget
	function widget_authdescription($args) {
		extract($args);
		$defaults = array('count' => 10, 'username' => 'wordpress');
		$options = (array) get_option('widget_authdescription');
		$bordercolor = $options['bordercolor'];
		foreach ( $defaults as $key => $value )
			if ( !isset($options[$key]) )
				$options[$key] = $defaults[$key];
?>
		<?php echo $before_widget; ?>
	
<h2><?php echo $options['title']?></h2>
			<?php
			
function print_profile() {
	global $wp_query, $blogownerid;
	global $wpdb;
	$gravatar_uid = get_option('bruk_gravatar_uid');
	if ($gravatar_uid != ' '){
		$temp_uid = $gravatar_uid;
		}else{
		$temp_uid = '1';
		}
	$blogownerid = $temp_uid;
	$userdata = get_userdata($blogownerid); 
 if ($userdata->description != '') { 
echo $userdata->description; }
}

function filechecking() {
	global $wp_query, $blogownerid;
	global $wpdb, $blog_id;
	$default = get_option('default_gravatar');
	$gravatar_uid = get_option('bruk_gravatar_uid');
	if ($gravatar_uid != ' '){
		$temp_uid = $gravatar_uid;
		}else{
		$temp_uid = '1';
		}
	$blogownerid = $temp_uid;
	$epost = $wpdb->get_var("SELECT user_email FROM $wpdb->users WHERE ID=".$blogownerid."");
	$lowercase = strtolower($epost);
	$md5 = md5($lowercase);
	$gravatar_profil = get_option('bruk_gravatar_profil');
	if($gravatar_profil == true){
	echo $before_widget . $before_title . $title . $after_title . "<ul>\n";
	echo "<img style='float: left; margin-right: 10px; border: none;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=40&amp;default=$default' alt='' />";
	}
}
?>

<a href="<?php echo get_bloginfo('url')."/about/"?>"><?php filechecking(); ?></a>

		<?php echo print_profile();
		echo "</ul>\n" . $after_widget;	?>
<?php
	}

	// Tell Dynamic Sidebar about our new widget and its control
	register_sidebar_widget('Author Profile', 'widget_authdescription');
	register_widget_control('Author Profile', 'widget_authdescription_control');

}

 //Widget for recent comments with Gravatars
 
 function widget_recent_comments_gravatars($args) {
	global $wpdb, $comments, $comment;
	extract($args);
	$options = get_option('widget_recent_comments_gravatars');
	$default = get_option('default_gravatar');
	$use_favico = get_option('bruk_gravatar_favico');
	$use_mbl = get_option('bruk_mbl_ikon');
	$title = empty($options['title']) ? __('Recent Comments Gravatars') : $options['title'];
	if ( !$number = (int) $options['number'] )
		$number = 5;
	else if ( $number < 1 )
		$number = 1;
	else if ( $number > 15 )
		$number = 15;

		$comments = $wpdb->get_results("SELECT comment_author, comment_author_email, comment_author_url, comment_ID, comment_post_ID FROM $wpdb->comments WHERE comment_approved = '1' ORDER BY comment_date_gmt DESC LIMIT $number");
	
?>

		<?php echo $before_widget; ?>
			<?php echo $before_title . $title . $after_title; ?>
			<ul id="recentcomments_gravs"><?php
			if ( $comments ) : foreach ($comments as $comment) :
				global $comment;
				$default = get_option('default_gravatar');
				$epost = $comment->comment_author_email;
				$lowercase = strtolower($epost);
				$lenke_temp = $comment->comment_author_url;
				if ( $lenke_temp == 'http://' || $lenke_temp == '') {
        			$lenke = get_option('home');
        		}else{
        			$lenke = $comment->comment_author_url;
        			if ($use_favico == true){
        				$favicon_url = getFavicon($lenke);
    						$default = $favicon_url;
    					if ($default == '')
    						$default = get_option('default_gravatar');
    					}
        		
        		}
        		if ($use_mbl == true && $default == get_option('default_gravatar')){
        		$default = "http://pub.mybloglog.com/coiserv.php?href=mailto:" . $lowercase . "&amp;n=". $lowercase;
        			}
				$lenke2 = '<a href="'.$lenke.'">'.$comment->comment_author.'</a>';
			echo  '<li class="recentcomments_gravs"><img style="float: left; margin-right: 10px; border: none; size: 10px" src="http://www.gravatar.com/avatar.php?gravatar_id=' . md5($lowercase) . '&amp;size=20&amp;default=' . $default . '" height="20px" width="20px" alt=""/>' . sprintf(__('%1$s on %2$s'), $lenke2 , '<a href="'. get_permalink($comment->comment_post_ID) . '#comment-' . $comment->comment_ID . '">' . get_the_title($comment->comment_post_ID) . '</a>') . '</li>';
			
			endforeach; endif;?></ul>
		<?php echo $after_widget; ?>
<?php
}

function wp_delete_recent_comments_cache_gravatars() {
	wp_cache_delete( 'recent_comments_gravatars', 'widget' );
}

function widget_recent_comments_control_gravatars() {
	$options = $newoptions = get_option('widget_recent_comments_gravatars');
	if ( $_POST["recent-comments-submit_gravatars"] ) {
		$newoptions['title'] = strip_tags(stripslashes($_POST["recent-comments-title_gravatars"]));
		$newoptions['number'] = (int) $_POST["recent-comments-number_gravatars"];
	}
	if ( $options != $newoptions ) {
		$options = $newoptions;
		update_option('widget_recent_comments_gravatars', $options);
		wp_delete_recent_comments_cache();
	}
	$title = attribute_escape($options['title']);
	if ( !$number = (int) $options['number'] )
		$number = 5;
?>
			<p><label for="recent-comments-title_gravatars"><?php _e('Title:'); ?> <input style="width: 250px;" id="recent-comments-title_gravatars" name="recent-comments-title_gravatars" type="text" value="<?php echo $title; ?>" /></label></p>
			<p><label for="recent-comments-number_gravatars"><?php _e('Number of comments to show:'); ?> <input style="width: 25px; text-align: center;" id="recent-comments-number_gravatars" name="recent-comments-number_gravatars" type="text" value="<?php echo $number; ?>" /></label> <?php _e('(at most 15)'); ?></p>
			<input type="hidden" id="recent-comments-submit_gravatars" name="recent-comments-submit_gravatars" value="1" />
<?php
}

function widget_recent_comments_style_gravatars() {
?>
<style type="text/css">.recentcomments_gravs a{display:inline !important;padding: 0 !important;margin: 0 !important;} </style>
<?php
}

function widget_recent_comments_gravatars_register() {
global $wp_version;
if (!function_exists('register_sidebar_widget')) {
		return;
	}
	$width = 320;
	$height = 90;
	if ( '2.1' == $wp_version || '2.2' == $wp_version || (!function_exists( 'wp_register_sidebar_widget' ))) {
		register_sidebar_widget('Recent Comments Gravatars', 'widget_recent_comments_gravatars');
		register_widget_control('Recent Comments Gravatars', 'widget_recent_comments_control_gravatars', $width, $height);
	} else {
		// v2.2.1+

	$dims = array('width' => 320, 'height' => 90);
	$class = array('classname' => 'widget_recent_comments_gravatars');
	wp_register_sidebar_widget('recent-comments_gravatars', __('Recent Comments Gravatars'), 'widget_recent_comments_gravatars', $class);
	wp_register_widget_control('recent-comments_gravatars', __('Recent Comments Gravatars'), 'widget_recent_comments_control_gravatars', $dims);
}
	if ( is_active_widget('widget_recent_comments_gravatars') )
		add_action('wp_head', 'widget_recent_comments_style_gravatars');
}

// End of widget for Recent Comments with Gravatars

//Trying to use favico.ico if no Gravatar exists and the user has lef an URL to use

function comment_favicon($before='<img src="', $after='" alt="" />') {
	global $comment, $wpdb;
    
     $posters_url = $wpdb->get_var("SELECT comment_author_url FROM `$wpdb->comments` WHERE `comment_ID` = '$comment_ID'");
	//$favicon_url = $wpdb->get_var("SELECT comment_favicon_url FROM `$wpdb->comments` WHERE `comment_ID` = '$comment->comment_ID'");
	if(!empty($posters_url))  
		if( $favicon_url = getFavicon($posters_url) )
    
    if(!empty($favicon_url))
		echo($before . $favicon_url . $after);
}



function getFavicon($url) {

	// start by fetching the contents of the URL they left...
	if( $html = @file_get_contents($url) ) {

		if (preg_match('/<link[^>]+rel="(?:shortcut )?icon"[^>]+?href="([^"]+?)"/si', $html, $matches)) {
			// Attempt to grab a favicon link from their webpage url

			$linkUrl = html_entity_decode($matches[1]);
			if (substr($linkUrl, 0, 1) == '/') {
				$urlParts = parse_url($url);
				$faviconURL = $urlParts['scheme'].'://'.$urlParts['host'].$linkUrl;
			} else if (substr($linkUrl, 0, 7) == 'http://') {
				$faviconURL = $linkUrl;
			} else if (substr($url, -1, 1) == '/') {
				$faviconURL = $url.$linkUrl;
			} else {
				$faviconURL = $url.'/'.$linkUrl;
			}

		} else {
			// If unsuccessful, attempt to "guess" the favicon location

			$urlParts = parse_url($url);
			$faviconURL = $urlParts['scheme'].'://'.$urlParts['host'].'/favicon.ico';

		}

		// Run a test to see if what we have attempted to get actually exists.
		if( $faviconURL_exists = url_validate($faviconURL) )
			return $faviconURL;

	} 

	// Finally, if we haven't 'returned' yet then there is nothing to see here.
	return false;
}

//Trying to validate the URL

function url_validate( $link ) {
		
	$url_parts = @parse_url( $link );

	if ( empty( $url_parts["host"] ) )
		return false;

	if ( !empty( $url_parts["path"] ) ) {
		$documentpath = $url_parts["path"];
	} else {
		$documentpath = "/";
	}

	if ( !empty( $url_parts["query"] ) )
		$documentpath .= "?" . $url_parts["query"];

	$host = $url_parts["host"];
	$port = $url_parts["port"];
	
	if ( empty($port) )
		$port = "80";

	$socket = @fsockopen( $host, $port, $errno, $errstr, 30 );
	
	if ( !$socket )
		return false;
		
	fwrite ($socket, "HEAD ".$documentpath." HTTP/1.0\r\nHost: $host\r\n\r\n");

	$http_response = fgets( $socket, 22 );

	$responses = "/(200 OK)|(30[0-9] Moved)/";
	if ( preg_match($responses, $http_response) ) {
		fclose($socket);
		return true;
	} else {
		return false;
	}

}

function ShowGravatar($id) {
	global $wp_query, $wpdb;
	$userdata = get_userdata($id); 
		 if ($userdata->description != '') { 
			$user_info = $userdata->description; 
			}else{
			$user_info = "To change this standard text, you have to enter som information about your self in the <em>Dashboard</em> -> <em>Users</em> -> <em>Your Profile</em>.";
			}
	$epost = $wpdb->get_var("SELECT user_email FROM $wpdb->users WHERE ID=".$id."");
	$lowercase = strtolower($epost);
	$md5 = md5($lowercase);
	$avatar = "<img style='float: left; margin-right: 10px; border: none;' src='http://www.gravatar.com/avatar.php?gravatar_id=$md5&amp;size=40&amp;default=$default' alt='' />";
	echo "<br/><div class='title'><ul>\n $avatar $user_info</div></ul>\n<br/>";
}
	

//remove_filter('comment_text','');
add_action('admin_menu', 'gravatar_admin_menu');
add_filter('get_comment_author_link', 'show_gravatar');
add_filter('the_content', 'show_gravatar_post',1);
add_action('plugins_loaded', 'widget_authdescription_init');
add_action('plugins_loaded', 'widget_recent_comments_gravatars_register', 1);

?>